<template>
    <div class="sidebar flex flex-col justify-start h-full overflow-hidden w-full">
      <div class="headline flex flex-shrink-0 flex-1 justify-between pr-2 lg:pl-5" :class="{'border-b border-gray-300': isScrolled}">
        <h2 v-if="!isMobile" class="text-2xl mb-3">Filter</h2>
        <Button :style="{ visibility: hasSearchParams() ? 'visible' : 'hidden' }" class="mb-3" size="small" @click="resetAll">Alles zurücksetzen</Button>
      </div>
      <div class="flex flex-col flex-grow overflow-y-auto pb-6" @scroll="setScrolled">
        <div class="search-container flex-shrink-0 flex flex-col pr-2 lg:px-5 mb-6">
          <SearchInput
            class="mb-3"
            field="location"
            label="Ort/Klostername"
            placeholder="Nach Ort/Klostername suchen..."
            @search="onSearch('location', $event)"/>
          <SearchInput
            class="mb-3"
            field="patrocinium"
            label="Patrozinium"
            placeholder="Nach Patrozinium suchen..."
            @search="onSearch('patrocinium', $event)"/>
          <SearchInput
            class="mb-6"
            field="number"
            label="Klosternummer"
            placeholder="Nach GSN, GND, Wikidata, etc. suchen..."
            @search="onSearch('number', $event)"/>

          <template v-for="(comp, i) in searchGroups" :key="i">
            <component
              class="mb-3"
              :is="comp"
              @change="onGroupChange($event, i)"
              @remove="onGroupRemove(i)"
              @search="search"
            ></component>
          </template>

          <Button
            class="self-start mb-3"
            size="small"
            icon="pi pi-plus"
            outlined
            label="Parameter hinzufügen"
            @click="addNewParam"
          >
          </Button>
          <Button class="self-start button-search" size="small" native-type="submit" @click="search">Suchen</Button>
          <p v-if="searchErrors" class="text-sm text-primary-500 mt-2">Suche konnte nicht ausgeführt werden. Bitte überprüfen Sie Ihre Eingaben.</p>
        </div>
        <div class="facets-container lg:px-5 pr-2 flex-grow">
          <Facet
            class="facet-diocese mb-4"
            :facet="facetDiocese"
            title="Bistümer"
            field="diocese"
            @facetChange="onFacetChange($event, 'diocese')"
          />
          <Facet
            class="facet-order mb-4"
            :facet="facetOrder"
            title="Orden"
            field="order"
            @facetChange="onFacetChange($event, 'order')" >
            <template v-slot:orderIcon="slotProps">
              <OrderIcon class="mr-1" :name="slotProps.icon"/>
            </template>
          </Facet>
          <Facet
            class="facet-gender"
            :facet="facetGender"
            :show-search="false"
            title="Geschlecht"
            field="gender"
            @facetChange="onFacetChange($event, 'gender')"
          />
        </div>
      </div>
    </div>
</template>

<script>
import Facet from '@/components/Facet.vue';
import OrderIcon from '@/components/OrderIcon.vue';
import SearchInput from '@/components/SearchInput.vue';
import SearchGroup from '@/components/SearchGroup.vue';

export default {
  name: 'Sidebar',
  components: {
    SearchInput,
    OrderIcon,
    Facet,
    SearchGroup,
  },
  data () {
    return {
      searchParams: {
        location: null,
        patrocinium: null,
        number: null,
      },
      searchGroups: [],
      searchGroupsParams: [],
      searchErrors: false,
      isScrolled: false,
    };
  },
  computed: {
    facetDiocese () {
      return this.$store.state.facetDiocese;
    },
    facetOrder () {
      return this.$store.state.facetOrder;
    },
    facetGender () {
      return this.$store.state.facetGender;
    },
    monasteriesQuery () {
      return this.$store.state.monasteriesQuery;
    },
    isMobile () {
      return this.$store.state.isMobile;
    },
  },
  methods: {
    search () {
      const searchQuery = [

        // Filter out empty values and create a flat params array out of values
        ...Object.keys(this.searchParams).reduce((acc, field) => {
          const values = this.searchParams[field];
          return values !== null ? [...acc, ...values.map(value => ({ field, value, operator: 'eq' }))] : acc;
        }, []),

        // Filter out empty values
        ...this.searchGroupsParams
          .filter(param => param.value !== null)
          .reduce((acc, cur) => {
            cur.value.forEach(value => {
              acc.push({
                field: cur.field,
                operator: cur.operator,
                value,
              });
            });
            return acc;
          }, []),

      ];
      
      //add additional fields that are set by the histogram
      const lastSearchQuery = this.$store.state.monasteriesQuery.search;
      if(lastSearchQuery) {
        lastSearchQuery.forEach(lastParam => {
          if (lastParam['field'] === 'foundationBefore' || lastParam['field'] === 'dissoulutionAfter') {
            searchQuery.push(lastParam)
          }
        })
      }
      const noErrors = this.validateSearchQuery(searchQuery);
      if (noErrors) {
        const keepFacets = true;
        this.$store.dispatch('search', { searchQuery, keepFacets } );
      } else {
        this.searchErrors = true;
      }
    },
    onSearch (field, values) {
      this.searchParams[field] = values.length > 0 ? values : null;
      this.search();
    },
    addNewParam () {
      this.searchGroups.push(SearchGroup);
    },
    validateSearchQuery (searchQuery) {
      // let noErrors = true;
      // const pattern = /[a-zäöüß\-A-ZÄÖÜ0-9\s]+?$/;
      //
      // searchQuery.forEach(param => {
      //   if (!pattern.test(param.value)) {
      //     noErrors = false;
      //   }
      // });

      return true;
    },
    onGroupChange (field, index) {
      field.value = field.value.length > 0 ? field.value : null;
      this.searchGroupsParams[index] = field;
    },
    onGroupRemove (index) {
      this.searchGroupsParams.splice(index, 1);
      this.searchGroups.splice(index, 1);
    },
    hasSearchParams () {
      const query = this.monasteriesQuery;
      return query.search !== null ||
        query.facetDiocese?.length > 0 ||
        query.facetOrder?.length > 0 ||
        query.facetGender?.length > 0;
    },
    resetAll () {
      this.searchParams = {
        location: null,
        patrocinium: null,
        number: null,
      };
      this.searchGroups = [];
      this.searchGroupsParams = [];
      this.$store.dispatch('resetAllFilters');
    },
    onHistogramFilter ({ from, to }) {
      // this.$store.dispatch('search', {
      //   query: {
      //     fields: [
      //       { field: 'orderFrom', value: from, operator: 'OR', operator: 'gt' },
      //       { field: 'orderTo', value: to, operator: 'AND', operator: 'lt' },
      //     ],
      //   },
      // });
    },
    onFacetChange (checkedList, field) {
      this.$store.dispatch('applyFacet', { values: checkedList, field });
    },
    setScrolled (event) {
      this.isScrolled = event.target.scrollTop > 0;
    },
  },
};
</script>

<style lang="scss" scoped>
.headline {
  @screen lg {
    padding-right: calc(1.25rem + 12px);
  }
}
.button-search {
  @apply ml-0;
}
</style>
